Index: NEMO/trunk/doc/latex/NEMO/subfiles/chap_DOM.tex
===================================================================
--- NEMO/trunk/doc/latex/NEMO/subfiles/chap_DOM.tex	(revision 11151)
+++ NEMO/trunk/doc/latex/NEMO/subfiles/chap_DOM.tex	(revision 11179)
@@ -345,5 +345,6 @@
 % Domain: Horizontal Grid (mesh) 
 % ================================================================
-\section{Horizontal grid mesh (\protect\mdl{domhgr})}
+\section[Horizontal grid mesh (\textit{domhgr.F90})]
+{Horizontal grid mesh (\protect\mdl{domhgr})}
 \label{sec:DOM_hgr}
 
@@ -451,5 +452,6 @@
 % Domain: Vertical Grid (domzgr)
 % ================================================================
-\section{Vertical grid (\protect\mdl{domzgr})}
+\section[Vertical grid (\textit{domzgr.F90})]
+{Vertical grid (\protect\mdl{domzgr})}
 \label{sec:DOM_zgr}
 %-----------------------------------------nam_zgr & namdom-------------------------------------------
@@ -480,5 +482,5 @@
       (d) hybrid $s-z$ coordinate,
       (e) hybrid $s-z$ coordinate with partial step, and
-      (f) same as (e) but in the non-linear free surface (\protect\np{ln\_linssh}~\forcode{= .false.}).
+      (f) same as (e) but in the non-linear free surface (\protect\np{ln\_linssh}\forcode{ = .false.}).
       Note that the non-linear free surface can be used with any of the 5 coordinates (a) to (e).
     }
@@ -491,12 +493,12 @@
 It is not intended as an option which can be enabled or disabled in the middle of an experiment.
 Three main choices are offered (\autoref{fig:z_zps_s_sps}):
-$z$-coordinate with full step bathymetry (\np{ln\_zco}~\forcode{= .true.}),
-$z$-coordinate with partial step bathymetry (\np{ln\_zps}~\forcode{= .true.}),
-or generalized, $s$-coordinate (\np{ln\_sco}~\forcode{= .true.}).
+$z$-coordinate with full step bathymetry (\np{ln\_zco}\forcode{ = .true.}),
+$z$-coordinate with partial step bathymetry (\np{ln\_zps}\forcode{ = .true.}),
+or generalized, $s$-coordinate (\np{ln\_sco}\forcode{ = .true.}).
 Hybridation of the three main coordinates are available:
 $s-z$ or $s-zps$ coordinate (\autoref{fig:z_zps_s_sps} and \autoref{fig:z_zps_s_sps}).
 By default a non-linear free surface is used: the coordinate follow the time-variation of the free surface so that
 the transformation is time dependent: $z(i,j,k,t)$ (\autoref{fig:z_zps_s_sps}).
-When a linear free surface is assumed (\np{ln\_linssh}~\forcode{= .true.}),
+When a linear free surface is assumed (\np{ln\_linssh}\forcode{ = .true.}),
 the vertical coordinate are fixed in time, but the seawater can move up and down across the $z_0$ surface
 (in other words, the top of the ocean in not a rigid-lid).
@@ -513,5 +515,5 @@
   N.B. in full step $z$-coordinate, a \ifile{bathy\_level} file can replace the \ifile{bathy\_meter} file,
   so that the computation of the number of wet ocean point in each water column is by-passed}.
-If \np{ln\_isfcav}~\forcode{= .true.}, an extra file input file (\ifile{isf\_draft\_meter}) describing
+If \np{ln\_isfcav}\forcode{ = .true.}, an extra file input file (\ifile{isf\_draft\_meter}) describing
 the ice shelf draft (in meters) is needed.
 
@@ -535,5 +537,5 @@
 %%%
 
-Unless a linear free surface is used (\np{ln\_linssh}~\forcode{= .false.}),
+Unless a linear free surface is used (\np{ln\_linssh}\forcode{ = .false.}),
 the arrays describing the grid point depths and vertical scale factors are three set of
 three dimensional arrays $(i,j,k)$ defined at \textit{before}, \textit{now} and \textit{after} time step.
@@ -541,5 +543,5 @@
 They are updated at each model time step using a fixed reference coordinate system which
 computer names have a $\_0$ suffix.
-When the linear free surface option is used (\np{ln\_linssh}~\forcode{= .true.}), \textit{before},
+When the linear free surface option is used (\np{ln\_linssh}\forcode{ = .true.}), \textit{before},
 \textit{now} and \textit{after} arrays are simply set one for all to their reference counterpart.
 
@@ -553,12 +555,12 @@
 (found in \ngn{namdom} namelist): 
 \begin{description}
-\item[\np{nn\_bathy}~\forcode{= 0}]:
+\item[\np{nn\_bathy}\forcode{ = 0}]:
   a flat-bottom domain is defined.
   The total depth $z_w (jpk)$ is given by the coordinate transformation.
   The domain can either be a closed basin or a periodic channel depending on the parameter \np{jperio}.
-\item[\np{nn\_bathy}~\forcode{= -1}]:
+\item[\np{nn\_bathy}\forcode{ = -1}]:
   a domain with a bump of topography one third of the domain width at the central latitude.
   This is meant for the "EEL-R5" configuration, a periodic or open boundary channel with a seamount.
-\item[\np{nn\_bathy}~\forcode{= 1}]:
+\item[\np{nn\_bathy}\forcode{ = 1}]:
   read a bathymetry and ice shelf draft (if needed).
   The \ifile{bathy\_meter} file (Netcdf format) provides the ocean depth (positive, in meters) at
@@ -571,5 +573,5 @@
   The \ifile{isfdraft\_meter} file (Netcdf format) provides the ice shelf draft (positive, in meters) at
   each grid point of the model grid.
-  This file is only needed if \np{ln\_isfcav}~\forcode{= .true.}.
+  This file is only needed if \np{ln\_isfcav}\forcode{ = .true.}.
   Defining the ice shelf draft will also define the ice shelf edge and the grounding line position.
 \end{description}
@@ -586,6 +588,6 @@
 %        z-coordinate  and reference coordinate transformation
 % -------------------------------------------------------------------------------------------------------------
-\subsection[$Z$-coordinate (\protect\np{ln\_zco}~\forcode{= .true.}) and ref. coordinate]
-				{$Z$-coordinate (\protect\np{ln\_zco}~\forcode{= .true.}) and reference coordinate}
+\subsection[$Z$-coordinate (\forcode{ln_zco = .true.}) and ref. coordinate]
+{$Z$-coordinate (\protect\np{ln\_zco}\forcode{ = .true.}) and reference coordinate}
 \label{subsec:DOM_zco}
 
@@ -616,5 +618,5 @@
 using parameters provided in the \ngn{namcfg} namelist.
 
-It is possible to define a simple regular vertical grid by giving zero stretching (\np{ppacr}~\forcode{= 0}).
+It is possible to define a simple regular vertical grid by giving zero stretching (\np{ppacr}\forcode{ = 0}).
 In that case, the parameters \jp{jpk} (number of $w$-levels) and
 \np{pphmax} (total ocean depth in meters) fully define the grid.
@@ -631,5 +633,5 @@
 a smooth hyperbolic tangent transition in between (\autoref{fig:zgr}).
 
-If the ice shelf cavities are opened (\np{ln\_isfcav}~\forcode{= .true.}), the definition of $z_0$ is the same.
+If the ice shelf cavities are opened (\np{ln\_isfcav}\forcode{ = .true.}), the definition of $z_0$ is the same.
 However, definition of $e_3^0$ at $t$- and $w$-points is respectively changed to:
 \begin{equation}
@@ -765,5 +767,6 @@
 %        z-coordinate with partial step
 % -------------------------------------------------------------------------------------------------------------
-\subsection{$Z$-coordinate with partial step (\protect\np{ln\_zps}~\forcode{= .true.})}
+\subsection[$Z$-coordinate with partial step (\forcode{ln_zps = .true.})]
+{$Z$-coordinate with partial step (\protect\np{ln\_zps}\forcode{ = .true.})}
 \label{subsec:DOM_zps}
 %--------------------------------------------namdom-------------------------------------------------------
@@ -796,5 +799,6 @@
 %        s-coordinate
 % -------------------------------------------------------------------------------------------------------------
-\subsection{$S$-coordinate (\protect\np{ln\_sco}~\forcode{= .true.})}
+\subsection[$S$-coordinate (\forcode{ln_sco = .true.})]
+{$S$-coordinate (\protect\np{ln\_sco}\forcode{ = .true.})}
 \label{subsec:DOM_sco}
 %------------------------------------------nam_zgr_sco---------------------------------------------------
@@ -803,5 +807,5 @@
 %--------------------------------------------------------------------------------------------------------------
 Options are defined in \ngn{namzgr\_sco}.
-In $s$-coordinate (\np{ln\_sco}~\forcode{= .true.}), the depth and thickness of the model levels are defined from
+In $s$-coordinate (\np{ln\_sco}\forcode{ = .true.}), the depth and thickness of the model levels are defined from
 the product of a depth field and either a stretching function or its derivative, respectively:
 
@@ -826,5 +830,5 @@
 
 The original default NEMO s-coordinate stretching is available if neither of the other options are specified as true
-(\np{ln\_s\_SH94}~\forcode{= .false.} and \np{ln\_s\_SF12}~\forcode{= .false.}).
+(\np{ln\_s\_SH94}\forcode{ = .false.} and \np{ln\_s\_SF12}\forcode{ = .false.}).
 This uses a depth independent $\tanh$ function for the stretching \citep{madec.delecluse.ea_JPO96}:
 
@@ -846,5 +850,5 @@
 
 A stretching function,
-modified from the commonly used \citet{song.haidvogel_JCP94} stretching (\np{ln\_s\_SH94}~\forcode{= .true.}),
+modified from the commonly used \citet{song.haidvogel_JCP94} stretching (\np{ln\_s\_SH94}\forcode{ = .true.}),
 is also available and is more commonly used for shelf seas modelling:
 
@@ -946,5 +950,6 @@
 %        z*- or s*-coordinate
 % -------------------------------------------------------------------------------------------------------------
-\subsection{\zstar- or \sstar-coordinate (\protect\np{ln\_linssh}~\forcode{= .false.})}
+\subsection[\zstar- or \sstar-coordinate (\forcode{ln_linssh = .false.})]
+{\zstar- or \sstar-coordinate (\protect\np{ln\_linssh}\forcode{ = .false.})}
 \label{subsec:DOM_zgr_star}
 
@@ -1014,5 +1019,6 @@
 % Domain: Initial State (dtatsd & istate)
 % ================================================================
-\section{Initial state (\protect\mdl{istate} and \protect\mdl{dtatsd})}
+\section[Initial state (\textit{istate.F90} and \textit{dtatsd.F90})]
+{Initial state (\protect\mdl{istate} and \protect\mdl{dtatsd})}
 \label{sec:DTA_tsd}
 %-----------------------------------------namtsd-------------------------------------------
@@ -1025,5 +1031,5 @@
 salinity fields is controlled through the \np{ln\_tsd\_ini} namelist parameter.
 \begin{description}
-\item[\np{ln\_tsd\_init}~\forcode{= .true.}]
+\item[\np{ln\_tsd\_init}\forcode{ = .true.}]
   use a T and S input files that can be given on the model grid itself or on their native input data grid.
   In the latter case,
@@ -1032,5 +1038,5 @@
   The information relative to the input files are given in the \np{sn\_tem} and \np{sn\_sal} structures.
   The computation is done in the \mdl{dtatsd} module.
-\item[\np{ln\_tsd\_init}~\forcode{= .false.}]
+\item[\np{ln\_tsd\_init}\forcode{ = .false.}]
   use constant salinity value of $35.5~psu$ and an analytical profile of temperature
   (typical of the tropical ocean), see \rou{istate\_t\_s} subroutine called from \mdl{istate} module.