Index: /NEMO/trunk/doc/latex/SI3/main/SI3_manual.ist
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/SI3_manual.ist	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/SI3_manual.ist	(revision 11181)
@@ -0,0 +1,1 @@
+link ../../global/index.ist
Index: /NEMO/trunk/doc/latex/SI3/main/blocks.idx
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/blocks.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/blocks.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/blocks.idx
Index: /NEMO/trunk/doc/latex/SI3/main/definitions.tex
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/definitions.tex	(revision 11180)
+++ /NEMO/trunk/doc/latex/SI3/main/definitions.tex	(revision 11181)
@@ -6,6 +6,6 @@
 
 %% Authors (thanks will apply to the second author)
-\def \1stauthor{}
-\def \2ndauthor{NEMO Sea Ice Working Group}
+\def \firstauthor{}
+\def \secondauthor{NEMO Sea Ice Working Group}
 
 %% IPSL publication number
Index: /NEMO/trunk/doc/latex/SI3/main/keys.idx
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/keys.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/keys.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/keys.idx
Index: /NEMO/trunk/doc/latex/SI3/main/modules.idx
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/modules.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/modules.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/modules.idx
Index: /NEMO/trunk/doc/latex/SI3/main/parameters.idx
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/parameters.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/parameters.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/parameters.idx
Index: /NEMO/trunk/doc/latex/SI3/main/routines.idx
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/routines.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/routines.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/routines.idx
Index: /NEMO/trunk/doc/latex/SI3/main/subroutines.idx
===================================================================
--- /NEMO/trunk/doc/latex/SI3/main/subroutines.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/SI3/main/subroutines.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/subroutines.idx
Index: /NEMO/trunk/doc/latex/TOP/main/TOP_manual.ist
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/TOP_manual.ist	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/TOP_manual.ist	(revision 11181)
@@ -0,0 +1,1 @@
+link ../../global/index.ist
Index: /NEMO/trunk/doc/latex/TOP/main/blocks.idx
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/blocks.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/blocks.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/blocks.idx
Index: /NEMO/trunk/doc/latex/TOP/main/definitions.tex
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/definitions.tex	(revision 11180)
+++ /NEMO/trunk/doc/latex/TOP/main/definitions.tex	(revision 11181)
@@ -6,6 +6,6 @@
 
 %% Authors (thanks will apply to the second author)
-\def \1stauthor{}
-\def \2ndauthor{NEMO TOP Working Group}
+\def \firstauthor{}
+\def \secondauthor{NEMO TOP Working Group}
 
 %% IPSL publication number
Index: /NEMO/trunk/doc/latex/TOP/main/keys.idx
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/keys.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/keys.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/keys.idx
Index: /NEMO/trunk/doc/latex/TOP/main/modules.idx
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/modules.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/modules.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/modules.idx
Index: /NEMO/trunk/doc/latex/TOP/main/parameters.idx
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/parameters.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/parameters.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/parameters.idx
Index: /NEMO/trunk/doc/latex/TOP/main/routines.idx
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/routines.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/routines.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/routines.idx
Index: /NEMO/trunk/doc/latex/TOP/main/subroutines.idx
===================================================================
--- /NEMO/trunk/doc/latex/TOP/main/subroutines.idx	(revision 11181)
+++ /NEMO/trunk/doc/latex/TOP/main/subroutines.idx	(revision 11181)
@@ -0,0 +1,1 @@
+link ../build/subroutines.idx