Index: /NEMO/trunk/doc/latex/.svnignore
===================================================================
--- /NEMO/trunk/doc/latex/.svnignore	(revision 11186)
+++ /NEMO/trunk/doc/latex/.svnignore	(revision 11187)
@@ -8,5 +8,7 @@
 *.ilg
 *.ind
+*.lof
 *.log
+*.lot
 *.maf
 *.mtc*
Index: /NEMO/trunk/doc/latex/DEPS
===================================================================
--- /NEMO/trunk/doc/latex/DEPS	(revision 11186)
+++ /NEMO/trunk/doc/latex/DEPS	(revision 11187)
@@ -25,4 +25,5 @@
 idxlayout
 ifplatform
+koma-script
 latex
 latex-bin
@@ -39,4 +40,5 @@
 oberdiek
 parskip
+preview
 psnfss
 subfiles
@@ -44,4 +46,5 @@
 times
 titlesec
+titling
 tools
 upquote
@@ -52,2 +55,4 @@
 xstring
 zapfchan
+
+
Index: /NEMO/trunk/doc/latex/HTML_latex2html.sh
===================================================================
--- /NEMO/trunk/doc/latex/HTML_latex2html.sh	(revision 11186)
+++ /NEMO/trunk/doc/latex/HTML_latex2html.sh	(revision 11187)
@@ -1,20 +1,27 @@
 #!/bin/bash
 
-./inc/clean.sh
-./inc/build.sh
+#./inc/clean.sh
+#./inc/build.sh
 
-cd tex_main
-sed -i -e 's#\\documentclass#%\\documentclass#' -e '/{document}/ s/^/%/' \
-	../tex_sub/*.tex
-sed -i    's#\\subfile{#\\include{#g' \
-	NEMO_manual.tex
-latex2html -local_icons -no_footnode -split 4 -link 2 -mkdir -dir ../html_LaTeX2HTML 	\
-				$* 																								\
-	NEMO_manual
-sed -i -e 's#%\\documentclass#\\documentclass#' -e '/{document}/ s/^%//' \
-	../tex_sub/*.tex
-sed -i    's#\\include{#\\subfile{#g' \
-	NEMO_manual.tex
+sed -i -e 's#utf8#latin1#'                                 \
+       -e 's#\[outputdir=../build\]{minted}#\[\]{minted}#' \
+       -e '/graphicspath/ s#{../#{../../#g'                \
+          global/packages.tex
+
+cd ./NEMO/main
+sed -i -e 's#\\documentclass#%\\documentclass#' -e '/{document}/ s#^#%#'   ../subfiles/*.tex
+sed -i    's#\\subfile{#\\input{#'                                         chapters.tex appendices.tex
+
+#latex2html                                   -noimages -local_icons -no_footnode -split 4 -link 2 -dir ../html_LaTeX2HTML $*	NEMO_manual
+latex2html -debug -noreuse -init_file ../../l2hconf.pm -local_icons                               -dir ../build/html               NEMO_manual
+
+sed -i -e 's#%\\documentclass#\\documentclass#' -e '/{document}/ s#^%##'   ../subfiles/*.tex
+sed -i    's#\\input{#\\subfile{#'                                         chapters.tex appendices.tex
 cd -
 
+sed -i -e 's#latin1#utf8#'                                 \
+       -e 's#\[\]{minted}#\[outputdir=../build\]{minted}#' \
+       -e '/graphicspath/ s#{../../#{../#g'                \
+	  global/packages.tex
+
 exit 0
Index: /NEMO/trunk/doc/latex/NEMO/main/appendices.tex
===================================================================
--- /NEMO/trunk/doc/latex/NEMO/main/appendices.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/NEMO/main/appendices.tex	(revision 11187)
@@ -1,2 +1,3 @@
+
 \subfile{../subfiles/annex_A}             %% Generalised vertical coordinate
 \subfile{../subfiles/annex_B}             %% Diffusive operator
@@ -10,2 +11,3 @@
 %\subfile{../subfiles/chap_conservation}
 %\subfile{../subfiles/annex_E}				%% Notes on some on going staff
+
Index: /NEMO/trunk/doc/latex/NEMO/subfiles/annex_iso.tex
===================================================================
--- /NEMO/trunk/doc/latex/NEMO/subfiles/annex_iso.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/NEMO/subfiles/annex_iso.tex	(revision 11187)
@@ -4,5 +4,6 @@
 \newcommand{\rML}[1][i]{\ensuremath{_{\mathrm{ML}\,#1}}}
 \newcommand{\rMLt}[1][i]{\tilde{r}_{\mathrm{ML}\,#1}}
-\newcommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}}
+%% Move to ../../global/new_cmds.tex to avoid error with \listoffigures
+%\newcommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}
 \newcommand{\triadd}[5]{\ensuremath{{}_{#1}^{#2}{\mathbb{#3}}_{#4}^{\,#5}}}
 \newcommand{\triadt}[5]{\ensuremath{{}_{#1}^{#2}{\tilde{\mathbb{#3}}}_{#4}^{\,#5}}}
Index: /NEMO/trunk/doc/latex/NEMO/subfiles/chap_DYN.tex
===================================================================
--- /NEMO/trunk/doc/latex/NEMO/subfiles/chap_DYN.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/NEMO/subfiles/chap_DYN.tex	(revision 11187)
@@ -829,5 +829,5 @@
 % Explicit free surface formulation
 %--------------------------------------------------------------------------------------------------------------
-\subsection[Explicit free surface (texttt{\textbf{key\_dynspg\_exp}})]
+\subsection[Explicit free surface (\texttt{\textbf{key\_dynspg\_exp}})]
 {Explicit free surface (\protect\key{dynspg\_exp})}
 \label{subsec:DYN_spg_exp}
@@ -856,5 +856,5 @@
 % Split-explict free surface formulation
 %--------------------------------------------------------------------------------------------------------------
-\subsection[Split-explicit free surface (texttt{\textbf{key\_dynspg\_ts}})]
+\subsection[Split-explicit free surface (\texttt{\textbf{key\_dynspg\_ts}})]
 {Split-explicit free surface (\protect\key{dynspg\_ts})}
 \label{subsec:DYN_spg_ts}
Index: /NEMO/trunk/doc/latex/global/document.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/document.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/global/document.tex	(revision 11187)
@@ -11,5 +11,5 @@
 
 %% Document layout
-\documentclass[draft]{scrreport}
+\documentclass[draft]{scrreprt}
 
 %% Load the configuration of the manual
@@ -60,5 +60,5 @@
 %% Table of Contents
 \tableofcontents
-%\listoffigures
+\listoffigures
 \listoftables
 
@@ -73,5 +73,5 @@
 \pagenumbering{arabic}
 
-\input{chapters}
+\include{chapters}
 
 
@@ -82,5 +82,5 @@
 \appendix   
 
-\input{appendices}
+\include{appendices}
 
 
Index: /NEMO/trunk/doc/latex/global/new_cmds.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/new_cmds.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/global/new_cmds.tex	(revision 11187)
@@ -36,2 +36,5 @@
 %% Namelists inclusion
 \newcommand{\nlst}[1]{\forfile{../../../namelists/#1}}
+
+%% Workaround for issue with \listoffigures
+\DeclareRobustCommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}}
Index: /NEMO/trunk/doc/latex/global/packages.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/packages.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/global/packages.tex	(revision 11187)
@@ -1,2 +1,3 @@
+
 %% LaTeX packages in use
 %% ==============================================================================
Index: /NEMO/trunk/doc/latex/global/preamble.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/preamble.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/global/preamble.tex	(revision 11187)
@@ -4,4 +4,4 @@
 \input{../../global/new_cmds}
 \input{../../global/styles}
-\input{../../global/todonotes}
+%\input{../../global/todonotes}
 
Index: /NEMO/trunk/doc/latex/global/styles.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/styles.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/global/styles.tex	(revision 11187)
@@ -1,2 +1,3 @@
+
 %% Styles
 %% ==============================================================================
@@ -4,4 +5,6 @@
 %\pagestyle{fancy}
 \bibliographystyle{../../global/ametsoc}
+\renewcommand{\bibpreamble}{\begin{multicols}{2}}
+\renewcommand{\bibpostamble}{\end{multicols}}
 
 %% Additionnal fonts
@@ -62,2 +65,4 @@
 %\def\@seccntformat#1{\protect\makebox[0pt][r]{\csname the#1\endcsname\quad}}
 %\makeatother
+
+
Index: /NEMO/trunk/doc/latex/global/todonotes.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/todonotes.tex	(revision 11186)
+++ /NEMO/trunk/doc/latex/global/todonotes.tex	(revision 11187)
@@ -1,2 +1,4 @@
+\usepackage[]{todonotes}
+
 \newcounter{ubcomment}
 \newcommand{\ubcomment}[2][]{%