Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 11199)
@@ -22,5 +22,5 @@
    cn_exp      = "Pacific" !  experience name
    nn_it000    =       1   !  first time step
-   nn_itend    =      75   !  last  time step (std 5475)
+   nn_itend    =      80   !  last  time step (std 5475)
    nn_istate   =       0   !  output the initial state (1) or not (0)
 /
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 11199)
@@ -22,5 +22,5 @@
    cn_exp      = "Nordic"  !  experience name 
    nn_it000    =    1      !  first time step
-   nn_itend    =  300      !  last  time step
+   nn_itend    =  320      !  last  time step
    nn_istate   =      0    !  output the initial state (1) or not (0)
    ln_clobber  = .true.    !  clobber (overwrite) an existing file
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 11199)
@@ -22,5 +22,5 @@
    cn_exp      = "Nordic"  !  experience name 
    nn_it000    =    1      !  first time step
-   nn_itend    =  900      !  last  time step
+   nn_itend    =  960      !  last  time step
    nn_istate   =      0    !  output the initial state (1) or not (0)
    ln_clobber  = .true.    !  clobber (overwrite) an existing file
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 11199)
@@ -22,5 +22,5 @@
    cn_exp      =  "ORCA2"  !  experience name
    nn_it000    =       1   !  first time step
-   nn_itend    =      75   !  last  time step (std 5475)
+   nn_itend    =      80   !  last  time step (std 5475)
    nn_istate   =       0   !  output the initial state (1) or not (0)
 /
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 11199)
@@ -22,5 +22,5 @@
    cn_exp      =  "ORCA2"  !  experience name
    nn_it000    =       1   !  first time step
-   nn_itend    =    5475   !  last  time step (std 5475)
+   nn_itend    =    5840   !  last  time step (std 5475)
    nn_istate   =       0   !  output the initial state (1) or not (0)
 /
@@ -75,5 +75,5 @@
 &namsbc        !   Surface Boundary Condition manager                   (default: NO selection)
 !-----------------------------------------------------------------------
-   nn_fsbc     = 2         !  frequency of SBC module call
+   nn_fsbc     = 4         !  frequency of SBC module call
                            !     (also = the frequency of sea-ice & iceberg model call)
                      ! Type of air-sea fluxes 
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/SHARED/namelist_ref
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/SHARED/namelist_ref	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/cfgs/SHARED/namelist_ref	(revision 11199)
@@ -189,5 +189,5 @@
 &namsbc        !   Surface Boundary Condition manager                   (default: NO selection)
 !-----------------------------------------------------------------------
-   nn_fsbc     = 2         !  frequency of SBC module call
+   nn_fsbc     = 4         !  frequency of SBC module call
       !                    !  (control sea-ice & iceberg model call)
                      ! Type of air-sea fluxes 
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/src/OCE/SBC/sbcapr.F90
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/src/OCE/SBC/sbcapr.F90	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/src/OCE/SBC/sbcapr.F90	(revision 11199)
@@ -26,8 +26,8 @@
    PUBLIC   sbc_apr_init  ! routine called in sbcmod
    
-   !                                !!* namsbc_apr namelist (Atmospheric PRessure) *
-   LOGICAL, PUBLIC ::   ln_apr_obc   !: inverse barometer added to OBC ssh data 
-   LOGICAL, PUBLIC ::   ln_ref_apr   !: ref. pressure: global mean Patm (F) or a constant (F)
-   REAL(wp)        ::   rn_pref      !  reference atmospheric pressure   [N/m2]
+   !                                          !!* namsbc_apr namelist (Atmospheric PRessure) *
+   LOGICAL, PUBLIC ::   ln_apr_obc = .false.   !: inverse barometer added to OBC ssh data 
+   LOGICAL, PUBLIC ::   ln_ref_apr             !: ref. pressure: global mean Patm (F) or a constant (F)
+   REAL(wp)        ::   rn_pref                !  reference atmospheric pressure   [N/m2]
 
    REAL(wp), ALLOCATABLE, SAVE, PUBLIC, DIMENSION(:,:) ::   ssh_ib    ! Inverse barometer now    sea surface height   [m]
Index: /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/tests/ICE_AGRIF/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/tests/ICE_AGRIF/EXPREF/file_def_nemo-ice.xml	(revision 11198)
+++ /NEMO/branches/2019/dev_r11117_obsasm_bugfixes/tests/ICE_AGRIF/EXPREF/file_def_nemo-ice.xml	(revision 11199)
@@ -23,6 +23,4 @@
         <field field_ref="icethic"          name="sithic_max" operation="maximum" />
         <field field_ref="icethic"          name="sithic_min" operation="minimum" />
-        <field field_ref="iceneg_pres"      name="sineg_pres" />
-        <field field_ref="iceneg_volu"      name="sineg_volu" />
         <field field_ref="fasticepres"      name="fasticepres" />
         <field field_ref="icevolu"          name="sivolu" />