Index: /utils/CI/fix_ticket2302_sette/sette_reference-configurations.sh
===================================================================
--- /utils/CI/fix_ticket2302_sette/sette_reference-configurations.sh	(revision 11210)
+++ /utils/CI/fix_ticket2302_sette/sette_reference-configurations.sh	(revision 11211)
@@ -162,5 +162,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n GYRE_PISCES_ST -r GYRE_PISCES -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n GYRE_PISCES_ST -r GYRE_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -302,5 +302,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_PISCES_ST -r ORCA2_ICE_PISCES -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_PISCES_ST -r ORCA2_ICE_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -543,5 +543,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_OFF_PISCES_ST -r ORCA2_OFF_PISCES -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_OFF_PISCES_ST -r ORCA2_OFF_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -733,5 +733,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AMM12_ST -r AMM12 -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AMM12_ST -r AMM12 -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -860,5 +860,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_SAS_ICE_ST -r ORCA2_SAS_ICE -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_SAS_ICE_ST -r ORCA2_SAS_ICE -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1112,5 +1112,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_ST -r AGRIF_DEMO -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_ST -r AGRIF_DEMO -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1381,5 +1381,5 @@
     export TEST_NAME="ORCA2"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_NOAGRIF_ST -r AGRIF_DEMO -j 8 add_key ${ADD_KEYS} del_key "key_agrif"
+    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_NOAGRIF_ST -r AGRIF_DEMO -j 8 add_key "${ADD_KEYS}" del_key "key_agrif"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1418,5 +1418,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n SPITZ12_ST -r SPITZ12 -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n SPITZ12_ST -r SPITZ12 -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
Index: /utils/CI/fix_ticket2302_sette/sette_test-cases.sh
===================================================================
--- /utils/CI/fix_ticket2302_sette/sette_test-cases.sh	(revision 11210)
+++ /utils/CI/fix_ticket2302_sette/sette_test-cases.sh	(revision 11211)
@@ -164,5 +164,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -261,5 +261,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -359,5 +359,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -536,5 +536,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -721,5 +721,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg