Index: /NEMO/trunk/doc/latex/DEPS
===================================================================
--- /NEMO/trunk/doc/latex/DEPS	(revision 11211)
+++ /NEMO/trunk/doc/latex/DEPS	(revision 11212)
@@ -23,10 +23,10 @@
 helvetic
 hyperref
-idxlayout
 ifplatform
+imakeidx
 koma-script
 latex
+latexconfig
 latex-bin
-latexconfig
 latex-fonts
 latexmk
@@ -53,6 +53,6 @@
 wrapfig
 xcolor
+xkeyval
 xstring
 zapfchan
 
-
Index: /NEMO/trunk/doc/latex/NEMO/main/thanks.tex
===================================================================
--- /NEMO/trunk/doc/latex/NEMO/main/thanks.tex	(revision 11211)
+++ /NEMO/trunk/doc/latex/NEMO/main/thanks.tex	(revision 11212)
@@ -1,1 +1,2 @@
-TBD
+J\'{e}r\^{o}me Chanut,
+Silvia Mocavero
Index: /NEMO/trunk/doc/latex/global/document.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/document.tex	(revision 11211)
+++ /NEMO/trunk/doc/latex/global/document.tex	(revision 11212)
@@ -62,4 +62,5 @@
 \listoffigures
 \listoftables
+\listoflistings
 
 \clearpage
Index: /NEMO/trunk/doc/latex/global/highlighting.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/highlighting.tex	(revision 11211)
+++ /NEMO/trunk/doc/latex/global/highlighting.tex	(revision 11212)
@@ -5,5 +5,7 @@
 
 %% Global highlighting style
-\setminted{style=emacs, fontsize=\scriptsize, breaklines, frame=leftline}
+\definecolor{bg}{HTML}{f8f8f8}
+\usemintedstyle{emacs}
+\setminted{bgcolor=bg, fontsize=\scriptsize, breaklines, frame=leftline}
 \setminted[xml]{style=borland} %% Specific per language
 
@@ -26,2 +28,6 @@
 \newmintinline[xmlcode]{xml}{    fontsize=auto, frame=lines}   % \xmlcode{...}
 \newmintinline[snippet]{console}{fontsize=auto, frame=lines}   % \snippet{...}
+
+%% Namelists inclusion
+\newcommand{\nlst}[1]{\forfile{../../../namelists/#1}}
+
Index: /NEMO/trunk/doc/latex/global/indexes.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/indexes.tex	(revision 11211)
+++ /NEMO/trunk/doc/latex/global/indexes.tex	(revision 11212)
@@ -27,4 +27,6 @@
 %  pdfauthor={\firstauthor and \secondauthor},
   colorlinks,
-  urlcolor=blue
+  citecolor=olive,
+  linkcolor=blue,
+  urlcolor=gray
 }
Index: /NEMO/trunk/doc/latex/global/latexmkrc
===================================================================
--- /NEMO/trunk/doc/latex/global/latexmkrc	(revision 11211)
+++ /NEMO/trunk/doc/latex/global/latexmkrc	(revision 11212)
@@ -1,6 +1,17 @@
 
-$silent = 1;
+## Defaults
+$silent   = 1;
 $pdf_mode = 1;
-$makeindex = "makeindex -s %R.ist %O -o %D %S";
-$pdflatex = 'pdflatex -shell-escape %O %S';
 
+## Using relative paths
+$ENV{'openout_any'}='a';
+$out_dir = '../build';
+
+## Custom cmds
+$makeindex = 'makeindex -s %R.ist %O -o %D %S';
+$pdflatex  = 'pdflatex -shell-escape %O %S';
+
+#@BIBINPUTS=('.', '../main');
+#$bibtex    = 'bibtex %O ../main/bibliography.bib';
+#$kpsewhich = 'kpsewhich bibliography.bib'
+
Index: /NEMO/trunk/doc/latex/global/new_cmds.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/new_cmds.tex	(revision 11211)
+++ /NEMO/trunk/doc/latex/global/new_cmds.tex	(revision 11212)
@@ -34,7 +34,4 @@
 \newcommand{\pd}[2][]{\ensuremath{\frac{\partial #1}{\partial #2}}}
 
-%% Namelists inclusion
-\newcommand{\nlst}[1]{\forfile{../../../namelists/#1}}
-
 %% Workaround for issue with \listoffigures
 \DeclareRobustCommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}}
Index: /NEMO/trunk/doc/latex/global/styles.tex
===================================================================
--- /NEMO/trunk/doc/latex/global/styles.tex	(revision 11211)
+++ /NEMO/trunk/doc/latex/global/styles.tex	(revision 11212)
@@ -8,5 +8,5 @@
 \renewcommand{\bibpostamble}{\end{multicols}}
 
-%% Additionnal fonts
+%% Additional fonts
 \DeclareMathAlphabet{\mathpzc}{OT1}{pzc}{m}{it}
 
Index: /NEMO/trunk/doc/manual_build.sh
===================================================================
--- /NEMO/trunk/doc/manual_build.sh	(revision 11211)
+++ /NEMO/trunk/doc/manual_build.sh	(revision 11212)
@@ -3,7 +3,4 @@
 ## Initialisation
 ##---------------
-
-## Env. variable for using relative paths with latexmk
-export openout_any='a'
 
 ## Default selection for models
Index: /NEMO/trunk/doc/tools/shr_func.sh
===================================================================
--- /NEMO/trunk/doc/tools/shr_func.sh	(revision 11211)
+++ /NEMO/trunk/doc/tools/shr_func.sh	(revision 11212)
@@ -4,5 +4,5 @@
     ## Not sure if this step is needed, guess latexmk should be able to detect a change
     printf "\t¤ Clean previous build"
-    find latex/$1/build -mindepth 1 -prune -exec rm -rf {} \;
+    find latex/$1/build -mindepth 1 -prune -not -name $1_manual.pyg -exec rm -rf {} \;
 
     ## HTML exports
@@ -17,5 +17,4 @@
     latexmk -r  ./latex/global/latexmkrc  \
 	    -cd ./latex/$1/main/$1_manual \
-	    -outdir=../build              \
 	    1> /dev/null
     [ -f ./latex/$1/build/$1_manual.pdf ] && mv ./latex/$1/build/$1_manual.pdf .